import { Http, RequestOptionsArgs } from '@angular/http';
import { Observable, Subject } from 'rxjs/Rx';
import { Config } from '../config';
import 'rxjs/add/operator/map';
import { Secure } from './authorised-request';
import 'rxjs/add/operator/mergeMap';
export interface ApiTokenStore {
    events: Subject<any>;
    get(): Observable<{
        authToken: string;
        refreshToken: string;
    }>;
}
export declare class ApiService {
    private http;
    private config;
    private secure;
    constructor(http: Http, config: Config, secure: Secure);
    authorisedPost(path: string, data: any, options?: RequestOptionsArgs): Observable<any>;
    authorisedFetch(path: string, options?: RequestOptionsArgs): Observable<any>;
    fetch(path: string, options?: RequestOptionsArgs): Observable<any>;
    post(path: string, data: any, options?: RequestOptionsArgs): Observable<any>;
    private getPath(path);
    private handleResponse(res);
}
export declare class ApiError extends Error {
    response: any;
    constructor(message: string, response: any);
}
