"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var config_1 = require('../config');
require('rxjs/add/operator/map');
require('rxjs/add/operator/mergeMap');
var ApiService = (function () {
    function ApiService(http, config, secure) {
        this.http = http;
        this.config = config;
        this.secure = secure;
    }
    ApiService.prototype.authorisedPost = function (path, data, options) {
        var _this = this;
        if (options === void 0) { options = {}; }
        return this.secure.authorisedRequest(options, function (options) {
            return _this.post(path, data, options);
        });
    };
    ApiService.prototype.authorisedFetch = function (path, options) {
        var _this = this;
        if (options === void 0) { options = {}; }
        return this.secure.authorisedRequest(options, function (options) {
            return _this.fetch(path, options);
        });
    };
    ApiService.prototype.fetch = function (path, options) {
        var url = this.getPath(path);
        return this.http.get(url, options).map(this.handleResponse);
    };
    ApiService.prototype.post = function (path, data, options) {
        var url = this.getPath(path);
        options = options || {};
        options = Object.assign({
            headers: new http_1.Headers({ 'Content-Type': 'application/json' })
        }, options);
        return this.http.post(url, JSON.stringify(data), options)
            .map(this.handleResponse);
    };
    ApiService.prototype.getPath = function (path) {
        return this.config.baseUrl + "/" + path;
    };
    ApiService.prototype.handleResponse = function (res) {
        if (res.status >= 400) {
            throw new ApiError('Bad status code', res);
        }
        return res.json();
    };
    ApiService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http, config_1.Config, Object])
    ], ApiService);
    return ApiService;
}());
exports.ApiService = ApiService;
var ApiError = (function (_super) {
    __extends(ApiError, _super);
    function ApiError(message, response) {
        _super.call(this, message);
        this.response = response;
    }
    ;
    return ApiError;
}(Error));
exports.ApiError = ApiError;
//# sourceMappingURL=api.js.map