import { ApiService } from './api';
import { MockBackend } from '@angular/http/testing';
import { BaseRequestOptions, Http } from '@angular/http';
import { Config } from '../config';
export interface ResponseExpectation {
    path: string;
    body?: Object;
    headers?: Object;
}
export declare class TestConfig extends Config {
    baseUrl: string;
}
export declare function setupProviders(): ({
    provide: typeof ApiService;
    deps: (typeof Http | typeof Config)[];
    useFactory: (http: any, config: any) => ApiService;
} | typeof MockBackend | typeof BaseRequestOptions | {
    provide: typeof Http;
    useFactory: (backend: any, options: any) => Http;
    deps: (typeof MockBackend | typeof BaseRequestOptions)[];
} | {
    provide: typeof Config;
    useClass: typeof TestConfig;
})[];
export declare class TestApi {
    private response;
    private error;
    private responseExpectation;
    constructor();
    respondWith(responseOpts?: any): this;
    respondWithError(error: Error): this;
    expect(responseExpectation: ResponseExpectation): this;
    test(t: (api: ApiService) => void): (done: any) => any;
}
