"use strict";
var http_1 = require('@angular/http');
require('rxjs/add/operator/map');
var authorisation_tokens_1 = require('./authorisation-tokens');
var RefreshAuthTokenService = (function () {
    function RefreshAuthTokenService(http, apiBaseUrl) {
        this.http = http;
        this.refreshUrl = apiBaseUrl + "/auth/refresh";
    }
    RefreshAuthTokenService.prototype.refresh = function (authToken, refreshToken) {
        var body = JSON.stringify({ refreshToken: refreshToken });
        var options = this.getRequestOptions(authToken);
        return this.http.post(this.refreshUrl, body, options)
            .map(function (res) {
            if (res.status !== 200) {
                throw new Error("Bad status code: " + res.status);
            }
            var response = res.json();
            return new authorisation_tokens_1.AuthorisationTokens(response.access_token, response.refresh_token, true);
        });
    };
    RefreshAuthTokenService.prototype.getRequestOptions = function (authToken) {
        var headers = new http_1.Headers();
        headers.append('Content-Type', 'application/json');
        headers.append('Authorization', "bearer " + authToken);
        return { headers: headers };
    };
    return RefreshAuthTokenService;
}());
exports.RefreshAuthTokenService = RefreshAuthTokenService;
//# sourceMappingURL=refresh-auth-token-service.js.map